#pragma once

#include <map>
#include <functional>
#include <string>
#include <memory>

#include "request/request.h"
#include "response/response.h"

class Router {
public:
    using Handler = std::function<bool(Request*)>;

    Router();

    void addRoute(const std::string& path, const Handler& handler);
    void route(const std::string& path, std::unique_ptr<Request> request);

private:
    void handleNotFound(const std::string& path, std::unique_ptr<Request> request);
    void handleInternalError(const std::exception& exception, std::unique_ptr<Request> request);

private:
    std::map<std::string, Handler> table;

};
